<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'MessageType' => '\\StructType\\MessageType',
            'AuthenticationType' => '\\StructType\\AuthenticationType',
            'AlexBusinessFocusType' => '\\StructType\\AlexBusinessFocusType',
            'AlexBusinessFocusTypeAlap' => '\\StructType\\AlexBusinessFocusTypeAlap',
            'AlaProviderInformationType' => '\\StructType\\AlaProviderInformationType',
            'ContactType' => '\\StructType\\ContactType',
            'ServiceDomainInformationType' => '\\StructType\\ServiceDomainInformationType',
            'SubscriptionType' => '\\StructType\\SubscriptionType',
            'SubscriptionLogType' => '\\StructType\\SubscriptionLogType',
            'SubscriptionEventType' => '\\StructType\\SubscriptionEventType',
            'FiberConnectionType' => '\\StructType\\FiberConnectionType',
            'FiberConnectionRequestType' => '\\StructType\\FiberConnectionRequestType',
            'SubscriptionEndPointType' => '\\StructType\\SubscriptionEndPointType',
            'ServiceType' => '\\StructType\\ServiceType',
            'ServiceConditionsType' => '\\StructType\\ServiceConditionsType',
            'ServiceReturnType' => '\\StructType\\ServiceReturnType',
            'CustomerEndPointType' => '\\StructType\\CustomerEndPointType',
            'L1BreakoutType' => '\\StructType\\L1BreakoutType',
            'CreateBOCChangeType' => '\\StructType\\CreateBOCChangeType',
            'BOCChangeOrderType' => '\\StructType\\BOCChangeOrderType',
            'BOCChangeType' => '\\StructType\\BOCChangeType',
            'BOCChangeLogType' => '\\StructType\\BOCChangeLogType',
            'BOCChangeEventType' => '\\StructType\\BOCChangeEventType',
            'L1HandoverEquipmentType' => '\\StructType\\L1HandoverEquipmentType',
            'L1HandoverObjectType' => '\\StructType\\L1HandoverObjectType',
            'SubscriptionSearchPatternType' => '\\StructType\\SubscriptionSearchPatternType',
            'SubscriptionEndPointSearchPatternType' => '\\StructType\\SubscriptionEndPointSearchPatternType',
            'BOCChangeSearchPatternType' => '\\StructType\\BOCChangeSearchPatternType',
            'TicketSearchPatternType' => '\\StructType\\TicketSearchPatternType',
            'ResultBasicType' => '\\StructType\\ResultBasicType',
            'ResultType' => '\\StructType\\ResultType',
            'SepResultType' => '\\StructType\\SepResultType',
            'TicketType' => '\\StructType\\TicketType',
            'CreateTicketType' => '\\StructType\\CreateTicketType',
            'UpdateTicketType' => '\\StructType\\UpdateTicketType',
            'CancelTicketType' => '\\StructType\\CancelTicketType',
            'CloseTicketType' => '\\StructType\\CloseTicketType',
            'CpeInformationType' => '\\StructType\\CpeInformationType',
            'AccessPortInformationType' => '\\StructType\\AccessPortInformationType',
            'HealthCheckResultType' => '\\StructType\\HealthCheckResultType',
            'getAlaProviderInformationRequestAlau' => '\\StructType\\GetAlaProviderInformationRequestAlau',
            'getAlaProviderInformationResponseAlau' => '\\StructType\\GetAlaProviderInformationResponseAlau',
            'getSubscriptionEndPointInformationRequestAlau' => '\\StructType\\GetSubscriptionEndPointInformationRequestAlau',
            'getSubscriptionEndPointInformationResponseAlau' => '\\StructType\\GetSubscriptionEndPointInformationResponseAlau',
            'getSubscriptionEndPointInformationRequestAlap' => '\\StructType\\GetSubscriptionEndPointInformationRequestAlap',
            'getSubscriptionEndPointInformationResponseAlap' => '\\StructType\\GetSubscriptionEndPointInformationResponseAlap',
            'getAvailableServicesRequestAlau' => '\\StructType\\GetAvailableServicesRequestAlau',
            'getAvailableServicesResponseAlau' => '\\StructType\\GetAvailableServicesResponseAlau',
            'getAvailableServicesRequestAlap' => '\\StructType\\GetAvailableServicesRequestAlap',
            'getAvailableServicesResponseAlap' => '\\StructType\\GetAvailableServicesResponseAlap',
            'getL1HandoverInformationRequestAlau' => '\\StructType\\GetL1HandoverInformationRequestAlau',
            'getL1HandoverInformationResponseAlau' => '\\StructType\\GetL1HandoverInformationResponseAlau',
            'getL1HandoverInformationRequestAlap' => '\\StructType\\GetL1HandoverInformationRequestAlap',
            'getL1HandoverInformationResponseAlap' => '\\StructType\\GetL1HandoverInformationResponseAlap',
            'getAlapCustomerEndPointRequest' => '\\StructType\\GetAlapCustomerEndPointRequest',
            'getAlapCustomerEndPointResponse' => '\\StructType\\GetAlapCustomerEndPointResponse',
            'createSubscriptionRequestAlau' => '\\StructType\\CreateSubscriptionRequestAlau',
            'createSubscriptionResponseAlau' => '\\StructType\\CreateSubscriptionResponseAlau',
            'createSubscriptionRequestAlap' => '\\StructType\\CreateSubscriptionRequestAlap',
            'createSubscriptionResponseAlap' => '\\StructType\\CreateSubscriptionResponseAlap',
            'updateSubscriptionRequestAlau' => '\\StructType\\UpdateSubscriptionRequestAlau',
            'updateSubscriptionResponseAlau' => '\\StructType\\UpdateSubscriptionResponseAlau',
            'updateSubscriptionRequestAlap' => '\\StructType\\UpdateSubscriptionRequestAlap',
            'updateSubscriptionResponseAlap' => '\\StructType\\UpdateSubscriptionResponseAlap',
            'cancelSubscriptionRequestAlau' => '\\StructType\\CancelSubscriptionRequestAlau',
            'cancelSubscriptionResponseAlau' => '\\StructType\\CancelSubscriptionResponseAlau',
            'cancelSubscriptionRequestAlap' => '\\StructType\\CancelSubscriptionRequestAlap',
            'cancelSubscriptionResponseAlap' => '\\StructType\\CancelSubscriptionResponseAlap',
            'relocateSubscriptionRequestAlau' => '\\StructType\\RelocateSubscriptionRequestAlau',
            'relocateSubscriptionResponseAlau' => '\\StructType\\RelocateSubscriptionResponseAlau',
            'relocateSubscriptionRequestAlap' => '\\StructType\\RelocateSubscriptionRequestAlap',
            'relocateSubscriptionResponseAlap' => '\\StructType\\RelocateSubscriptionResponseAlap',
            'terminateSubscriptionRequestAlau' => '\\StructType\\TerminateSubscriptionRequestAlau',
            'terminateSubscriptionResponseAlau' => '\\StructType\\TerminateSubscriptionResponseAlau',
            'terminateSubscriptionRequestAlap' => '\\StructType\\TerminateSubscriptionRequestAlap',
            'terminateSubscriptionResponseAlap' => '\\StructType\\TerminateSubscriptionResponseAlap',
            'getSubscriptionInformationRequestAlau' => '\\StructType\\GetSubscriptionInformationRequestAlau',
            'getSubscriptionInformationResponseAlau' => '\\StructType\\GetSubscriptionInformationResponseAlau',
            'getSubscriptionInformationRequestAlap' => '\\StructType\\GetSubscriptionInformationRequestAlap',
            'getSubscriptionInformationResponseAlap' => '\\StructType\\GetSubscriptionInformationResponseAlap',
            'createBOCChangeRequestAlau' => '\\StructType\\CreateBOCChangeRequestAlau',
            'createBOCChangeResponseAlau' => '\\StructType\\CreateBOCChangeResponseAlau',
            'createBOCChangeRequestAlap' => '\\StructType\\CreateBOCChangeRequestAlap',
            'createBOCChangeResponseAlap' => '\\StructType\\CreateBOCChangeResponseAlap',
            'getBOCChangeInformationRequestAlau' => '\\StructType\\GetBOCChangeInformationRequestAlau',
            'getBOCChangeInformationResponseAlau' => '\\StructType\\GetBOCChangeInformationResponseAlau',
            'getBOCChangeInformationRequestAlap' => '\\StructType\\GetBOCChangeInformationRequestAlap',
            'getBOCChangeInformationResponseAlap' => '\\StructType\\GetBOCChangeInformationResponseAlap',
            'createTicketRequestAlau' => '\\StructType\\CreateTicketRequestAlau',
            'createTicketResponseAlau' => '\\StructType\\CreateTicketResponseAlau',
            'createTicketRequestAlap' => '\\StructType\\CreateTicketRequestAlap',
            'createTicketResponseAlap' => '\\StructType\\CreateTicketResponseAlap',
            'updateTicketRequestAlau' => '\\StructType\\UpdateTicketRequestAlau',
            'updateTicketResponseAlau' => '\\StructType\\UpdateTicketResponseAlau',
            'updateTicketRequestAlap' => '\\StructType\\UpdateTicketRequestAlap',
            'updateTicketResponseAlap' => '\\StructType\\UpdateTicketResponseAlap',
            'cancelTicketRequestAlau' => '\\StructType\\CancelTicketRequestAlau',
            'cancelTicketResponseAlau' => '\\StructType\\CancelTicketResponseAlau',
            'cancelTicketRequestAlap' => '\\StructType\\CancelTicketRequestAlap',
            'cancelTicketResponseAlap' => '\\StructType\\CancelTicketResponseAlap',
            'closeTicketRequestAlau' => '\\StructType\\CloseTicketRequestAlau',
            'closeTicketResponseAlau' => '\\StructType\\CloseTicketResponseAlau',
            'closeTicketRequestAlap' => '\\StructType\\CloseTicketRequestAlap',
            'closeTicketResponseAlap' => '\\StructType\\CloseTicketResponseAlap',
            'getTicketRequestAlau' => '\\StructType\\GetTicketRequestAlau',
            'getTicketResponseAlau' => '\\StructType\\GetTicketResponseAlau',
            'getTicketRequestAlap' => '\\StructType\\GetTicketRequestAlap',
            'getTicketResponseAlap' => '\\StructType\\GetTicketResponseAlap',
            'healthCheckRequestAlau' => '\\StructType\\HealthCheckRequestAlau',
            'healthCheckResponseAlau' => '\\StructType\\HealthCheckResponseAlau',
            'healthCheckRequestAlap' => '\\StructType\\HealthCheckRequestAlap',
            'healthCheckResponseAlap' => '\\StructType\\HealthCheckResponseAlap',
            'restartCpeRequestAlau' => '\\StructType\\RestartCpeRequestAlau',
            'restartCpeResponseAlau' => '\\StructType\\RestartCpeResponseAlau',
            'restartCpeRequestAlap' => '\\StructType\\RestartCpeRequestAlap',
            'restartCpeResponseAlap' => '\\StructType\\RestartCpeResponseAlap',
        );
    }
}
