<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlexBusinessFocusType StructType
 * @subpackage Structs
 */
class AlexBusinessFocusType extends AbstractStructBase
{
    /**
     * The alaProviderId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var int
     */
    public $alaProviderId;
    /**
     * The serviceDomainId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var int
     */
    public $serviceDomainId;
    /**
     * Constructor method for AlexBusinessFocusType
     * @uses AlexBusinessFocusType::setAlaProviderId()
     * @uses AlexBusinessFocusType::setServiceDomainId()
     * @param int $alaProviderId
     * @param int $serviceDomainId
     */
    public function __construct($alaProviderId = null, $serviceDomainId = null)
    {
        $this
            ->setAlaProviderId($alaProviderId)
            ->setServiceDomainId($serviceDomainId);
    }
    /**
     * Get alaProviderId value
     * @return int|null
     */
    public function getAlaProviderId()
    {
        return $this->alaProviderId;
    }
    /**
     * Set alaProviderId value
     * @param int $alaProviderId
     * @return \StructType\AlexBusinessFocusType
     */
    public function setAlaProviderId($alaProviderId = null)
    {
        // validation for constraint: int
        if (!is_null($alaProviderId) && !(is_int($alaProviderId) || ctype_digit($alaProviderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($alaProviderId, true), gettype($alaProviderId)), __LINE__);
        }
        $this->alaProviderId = $alaProviderId;
        return $this;
    }
    /**
     * Get serviceDomainId value
     * @return int|null
     */
    public function getServiceDomainId()
    {
        return $this->serviceDomainId;
    }
    /**
     * Set serviceDomainId value
     * @param int $serviceDomainId
     * @return \StructType\AlexBusinessFocusType
     */
    public function setServiceDomainId($serviceDomainId = null)
    {
        // validation for constraint: int
        if (!is_null($serviceDomainId) && !(is_int($serviceDomainId) || ctype_digit($serviceDomainId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviceDomainId, true), gettype($serviceDomainId)), __LINE__);
        }
        $this->serviceDomainId = $serviceDomainId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AlexBusinessFocusType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
