<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BOCChangeLogType StructType
 * @subpackage Structs
 */
class BOCChangeLogType extends AbstractStructBase
{
    /**
     * The bocChangeEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\BOCChangeEventType[]
     */
    public $bocChangeEvent;
    /**
     * Constructor method for BOCChangeLogType
     * @uses BOCChangeLogType::setBocChangeEvent()
     * @param \StructType\BOCChangeEventType[] $bocChangeEvent
     */
    public function __construct(array $bocChangeEvent = array())
    {
        $this
            ->setBocChangeEvent($bocChangeEvent);
    }
    /**
     * Get bocChangeEvent value
     * @return \StructType\BOCChangeEventType[]|null
     */
    public function getBocChangeEvent()
    {
        return $this->bocChangeEvent;
    }
    /**
     * This method is responsible for validating the values passed to the setBocChangeEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBocChangeEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBocChangeEventForArrayConstraintsFromSetBocChangeEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bOCChangeLogTypeBocChangeEventItem) {
            // validation for constraint: itemType
            if (!$bOCChangeLogTypeBocChangeEventItem instanceof \StructType\BOCChangeEventType) {
                $invalidValues[] = is_object($bOCChangeLogTypeBocChangeEventItem) ? get_class($bOCChangeLogTypeBocChangeEventItem) : sprintf('%s(%s)', gettype($bOCChangeLogTypeBocChangeEventItem), var_export($bOCChangeLogTypeBocChangeEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bocChangeEvent property can only contain items of type \StructType\BOCChangeEventType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bocChangeEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\BOCChangeEventType[] $bocChangeEvent
     * @return \StructType\BOCChangeLogType
     */
    public function setBocChangeEvent(array $bocChangeEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($bocChangeEventArrayErrorMessage = self::validateBocChangeEventForArrayConstraintsFromSetBocChangeEvent($bocChangeEvent))) {
            throw new \InvalidArgumentException($bocChangeEventArrayErrorMessage, __LINE__);
        }
        $this->bocChangeEvent = $bocChangeEvent;
        return $this;
    }
    /**
     * Add item to bocChangeEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\BOCChangeEventType $item
     * @return \StructType\BOCChangeLogType
     */
    public function addToBocChangeEvent(\StructType\BOCChangeEventType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BOCChangeEventType) {
            throw new \InvalidArgumentException(sprintf('The bocChangeEvent property can only contain items of type \StructType\BOCChangeEventType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bocChangeEvent[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BOCChangeLogType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
