<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cancelTicketRequestAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P request description for the method "cancelTicket".
 * @subpackage Structs
 */
class CancelTicketRequestAlap extends AbstractStructBase
{
    /**
     * The authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\AuthenticationType
     */
    public $authentication;
    /**
     * The cancelTicket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\CancelTicketType
     */
    public $cancelTicket;
    /**
     * The focus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\AlexBusinessFocusTypeAlap
     */
    public $focus;
    /**
     * Constructor method for cancelTicketRequestAlap
     * @uses CancelTicketRequestAlap::setAuthentication()
     * @uses CancelTicketRequestAlap::setCancelTicket()
     * @uses CancelTicketRequestAlap::setFocus()
     * @param \StructType\AuthenticationType $authentication
     * @param \StructType\CancelTicketType $cancelTicket
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     */
    public function __construct(\StructType\AuthenticationType $authentication = null, \StructType\CancelTicketType $cancelTicket = null, \StructType\AlexBusinessFocusTypeAlap $focus = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setCancelTicket($cancelTicket)
            ->setFocus($focus);
    }
    /**
     * Get authentication value
     * @return \StructType\AuthenticationType
     */
    public function getAuthentication()
    {
        return $this->authentication;
    }
    /**
     * Set authentication value
     * @param \StructType\AuthenticationType $authentication
     * @return \StructType\CancelTicketRequestAlap
     */
    public function setAuthentication(\StructType\AuthenticationType $authentication = null)
    {
        $this->authentication = $authentication;
        return $this;
    }
    /**
     * Get cancelTicket value
     * @return \StructType\CancelTicketType
     */
    public function getCancelTicket()
    {
        return $this->cancelTicket;
    }
    /**
     * Set cancelTicket value
     * @param \StructType\CancelTicketType $cancelTicket
     * @return \StructType\CancelTicketRequestAlap
     */
    public function setCancelTicket(\StructType\CancelTicketType $cancelTicket = null)
    {
        $this->cancelTicket = $cancelTicket;
        return $this;
    }
    /**
     * Get focus value
     * @return \StructType\AlexBusinessFocusTypeAlap|null
     */
    public function getFocus()
    {
        return $this->focus;
    }
    /**
     * Set focus value
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     * @return \StructType\CancelTicketRequestAlap
     */
    public function setFocus(\StructType\AlexBusinessFocusTypeAlap $focus = null)
    {
        $this->focus = $focus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelTicketRequestAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
