<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactType StructType
 * @subpackage Structs
 */
class ContactType extends AbstractStructBase
{
    /**
     * The contactNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactNo;
    /**
     * The agreementNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $agreementNo;
    /**
     * The contactFirstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactFirstName;
    /**
     * The contactLastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactLastName;
    /**
     * The contactCompanyName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactCompanyName;
    /**
     * The contactStreet
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactStreet;
    /**
     * The contactStreetNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactStreetNo;
    /**
     * The contactPostalCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactPostalCode;
    /**
     * The contactCity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactCity;
    /**
     * The contactCountry
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactCountry;
    /**
     * The contactPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactPhone;
    /**
     * The contactPhoneCell
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactPhoneCell;
    /**
     * The contactPhoneWork
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactPhoneWork;
    /**
     * The contactEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactEmail;
    /**
     * The contactNotes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $contactNotes;
    /**
     * Constructor method for ContactType
     * @uses ContactType::setContactNo()
     * @uses ContactType::setAgreementNo()
     * @uses ContactType::setContactFirstName()
     * @uses ContactType::setContactLastName()
     * @uses ContactType::setContactCompanyName()
     * @uses ContactType::setContactStreet()
     * @uses ContactType::setContactStreetNo()
     * @uses ContactType::setContactPostalCode()
     * @uses ContactType::setContactCity()
     * @uses ContactType::setContactCountry()
     * @uses ContactType::setContactPhone()
     * @uses ContactType::setContactPhoneCell()
     * @uses ContactType::setContactPhoneWork()
     * @uses ContactType::setContactEmail()
     * @uses ContactType::setContactNotes()
     * @param string $contactNo
     * @param string $agreementNo
     * @param string $contactFirstName
     * @param string $contactLastName
     * @param string $contactCompanyName
     * @param string $contactStreet
     * @param string $contactStreetNo
     * @param string $contactPostalCode
     * @param string $contactCity
     * @param string $contactCountry
     * @param string $contactPhone
     * @param string $contactPhoneCell
     * @param string $contactPhoneWork
     * @param string $contactEmail
     * @param string $contactNotes
     */
    public function __construct($contactNo = null, $agreementNo = null, $contactFirstName = null, $contactLastName = null, $contactCompanyName = null, $contactStreet = null, $contactStreetNo = null, $contactPostalCode = null, $contactCity = null, $contactCountry = null, $contactPhone = null, $contactPhoneCell = null, $contactPhoneWork = null, $contactEmail = null, $contactNotes = null)
    {
        $this
            ->setContactNo($contactNo)
            ->setAgreementNo($agreementNo)
            ->setContactFirstName($contactFirstName)
            ->setContactLastName($contactLastName)
            ->setContactCompanyName($contactCompanyName)
            ->setContactStreet($contactStreet)
            ->setContactStreetNo($contactStreetNo)
            ->setContactPostalCode($contactPostalCode)
            ->setContactCity($contactCity)
            ->setContactCountry($contactCountry)
            ->setContactPhone($contactPhone)
            ->setContactPhoneCell($contactPhoneCell)
            ->setContactPhoneWork($contactPhoneWork)
            ->setContactEmail($contactEmail)
            ->setContactNotes($contactNotes);
    }
    /**
     * Get contactNo value
     * @return string|null
     */
    public function getContactNo()
    {
        return $this->contactNo;
    }
    /**
     * Set contactNo value
     * @param string $contactNo
     * @return \StructType\ContactType
     */
    public function setContactNo($contactNo = null)
    {
        // validation for constraint: string
        if (!is_null($contactNo) && !is_string($contactNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactNo, true), gettype($contactNo)), __LINE__);
        }
        $this->contactNo = $contactNo;
        return $this;
    }
    /**
     * Get agreementNo value
     * @return string|null
     */
    public function getAgreementNo()
    {
        return $this->agreementNo;
    }
    /**
     * Set agreementNo value
     * @param string $agreementNo
     * @return \StructType\ContactType
     */
    public function setAgreementNo($agreementNo = null)
    {
        // validation for constraint: string
        if (!is_null($agreementNo) && !is_string($agreementNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agreementNo, true), gettype($agreementNo)), __LINE__);
        }
        $this->agreementNo = $agreementNo;
        return $this;
    }
    /**
     * Get contactFirstName value
     * @return string|null
     */
    public function getContactFirstName()
    {
        return $this->contactFirstName;
    }
    /**
     * Set contactFirstName value
     * @param string $contactFirstName
     * @return \StructType\ContactType
     */
    public function setContactFirstName($contactFirstName = null)
    {
        // validation for constraint: string
        if (!is_null($contactFirstName) && !is_string($contactFirstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactFirstName, true), gettype($contactFirstName)), __LINE__);
        }
        $this->contactFirstName = $contactFirstName;
        return $this;
    }
    /**
     * Get contactLastName value
     * @return string|null
     */
    public function getContactLastName()
    {
        return $this->contactLastName;
    }
    /**
     * Set contactLastName value
     * @param string $contactLastName
     * @return \StructType\ContactType
     */
    public function setContactLastName($contactLastName = null)
    {
        // validation for constraint: string
        if (!is_null($contactLastName) && !is_string($contactLastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactLastName, true), gettype($contactLastName)), __LINE__);
        }
        $this->contactLastName = $contactLastName;
        return $this;
    }
    /**
     * Get contactCompanyName value
     * @return string|null
     */
    public function getContactCompanyName()
    {
        return $this->contactCompanyName;
    }
    /**
     * Set contactCompanyName value
     * @param string $contactCompanyName
     * @return \StructType\ContactType
     */
    public function setContactCompanyName($contactCompanyName = null)
    {
        // validation for constraint: string
        if (!is_null($contactCompanyName) && !is_string($contactCompanyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactCompanyName, true), gettype($contactCompanyName)), __LINE__);
        }
        $this->contactCompanyName = $contactCompanyName;
        return $this;
    }
    /**
     * Get contactStreet value
     * @return string|null
     */
    public function getContactStreet()
    {
        return $this->contactStreet;
    }
    /**
     * Set contactStreet value
     * @param string $contactStreet
     * @return \StructType\ContactType
     */
    public function setContactStreet($contactStreet = null)
    {
        // validation for constraint: string
        if (!is_null($contactStreet) && !is_string($contactStreet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactStreet, true), gettype($contactStreet)), __LINE__);
        }
        $this->contactStreet = $contactStreet;
        return $this;
    }
    /**
     * Get contactStreetNo value
     * @return string|null
     */
    public function getContactStreetNo()
    {
        return $this->contactStreetNo;
    }
    /**
     * Set contactStreetNo value
     * @param string $contactStreetNo
     * @return \StructType\ContactType
     */
    public function setContactStreetNo($contactStreetNo = null)
    {
        // validation for constraint: string
        if (!is_null($contactStreetNo) && !is_string($contactStreetNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactStreetNo, true), gettype($contactStreetNo)), __LINE__);
        }
        $this->contactStreetNo = $contactStreetNo;
        return $this;
    }
    /**
     * Get contactPostalCode value
     * @return string|null
     */
    public function getContactPostalCode()
    {
        return $this->contactPostalCode;
    }
    /**
     * Set contactPostalCode value
     * @param string $contactPostalCode
     * @return \StructType\ContactType
     */
    public function setContactPostalCode($contactPostalCode = null)
    {
        // validation for constraint: string
        if (!is_null($contactPostalCode) && !is_string($contactPostalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactPostalCode, true), gettype($contactPostalCode)), __LINE__);
        }
        $this->contactPostalCode = $contactPostalCode;
        return $this;
    }
    /**
     * Get contactCity value
     * @return string|null
     */
    public function getContactCity()
    {
        return $this->contactCity;
    }
    /**
     * Set contactCity value
     * @param string $contactCity
     * @return \StructType\ContactType
     */
    public function setContactCity($contactCity = null)
    {
        // validation for constraint: string
        if (!is_null($contactCity) && !is_string($contactCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactCity, true), gettype($contactCity)), __LINE__);
        }
        $this->contactCity = $contactCity;
        return $this;
    }
    /**
     * Get contactCountry value
     * @return string|null
     */
    public function getContactCountry()
    {
        return $this->contactCountry;
    }
    /**
     * Set contactCountry value
     * @param string $contactCountry
     * @return \StructType\ContactType
     */
    public function setContactCountry($contactCountry = null)
    {
        // validation for constraint: string
        if (!is_null($contactCountry) && !is_string($contactCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactCountry, true), gettype($contactCountry)), __LINE__);
        }
        $this->contactCountry = $contactCountry;
        return $this;
    }
    /**
     * Get contactPhone value
     * @return string|null
     */
    public function getContactPhone()
    {
        return $this->contactPhone;
    }
    /**
     * Set contactPhone value
     * @param string $contactPhone
     * @return \StructType\ContactType
     */
    public function setContactPhone($contactPhone = null)
    {
        // validation for constraint: string
        if (!is_null($contactPhone) && !is_string($contactPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactPhone, true), gettype($contactPhone)), __LINE__);
        }
        $this->contactPhone = $contactPhone;
        return $this;
    }
    /**
     * Get contactPhoneCell value
     * @return string|null
     */
    public function getContactPhoneCell()
    {
        return $this->contactPhoneCell;
    }
    /**
     * Set contactPhoneCell value
     * @param string $contactPhoneCell
     * @return \StructType\ContactType
     */
    public function setContactPhoneCell($contactPhoneCell = null)
    {
        // validation for constraint: string
        if (!is_null($contactPhoneCell) && !is_string($contactPhoneCell)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactPhoneCell, true), gettype($contactPhoneCell)), __LINE__);
        }
        $this->contactPhoneCell = $contactPhoneCell;
        return $this;
    }
    /**
     * Get contactPhoneWork value
     * @return string|null
     */
    public function getContactPhoneWork()
    {
        return $this->contactPhoneWork;
    }
    /**
     * Set contactPhoneWork value
     * @param string $contactPhoneWork
     * @return \StructType\ContactType
     */
    public function setContactPhoneWork($contactPhoneWork = null)
    {
        // validation for constraint: string
        if (!is_null($contactPhoneWork) && !is_string($contactPhoneWork)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactPhoneWork, true), gettype($contactPhoneWork)), __LINE__);
        }
        $this->contactPhoneWork = $contactPhoneWork;
        return $this;
    }
    /**
     * Get contactEmail value
     * @return string|null
     */
    public function getContactEmail()
    {
        return $this->contactEmail;
    }
    /**
     * Set contactEmail value
     * @param string $contactEmail
     * @return \StructType\ContactType
     */
    public function setContactEmail($contactEmail = null)
    {
        // validation for constraint: string
        if (!is_null($contactEmail) && !is_string($contactEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactEmail, true), gettype($contactEmail)), __LINE__);
        }
        $this->contactEmail = $contactEmail;
        return $this;
    }
    /**
     * Get contactNotes value
     * @return string|null
     */
    public function getContactNotes()
    {
        return $this->contactNotes;
    }
    /**
     * Set contactNotes value
     * @param string $contactNotes
     * @return \StructType\ContactType
     */
    public function setContactNotes($contactNotes = null)
    {
        // validation for constraint: string
        if (!is_null($contactNotes) && !is_string($contactNotes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactNotes, true), gettype($contactNotes)), __LINE__);
        }
        $this->contactNotes = $contactNotes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
