<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createBOCChangeRequestAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P request description for the method "createBOCChange".
 * @subpackage Structs
 */
class CreateBOCChangeRequestAlap extends AbstractStructBase
{
    /**
     * The authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\AuthenticationType
     */
    public $authentication;
    /**
     * The focus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\AlexBusinessFocusTypeAlap
     */
    public $focus;
    /**
     * The createBOCChangeOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\CreateBOCChangeType
     */
    public $createBOCChangeOrder;
    /**
     * Constructor method for createBOCChangeRequestAlap
     * @uses CreateBOCChangeRequestAlap::setAuthentication()
     * @uses CreateBOCChangeRequestAlap::setFocus()
     * @uses CreateBOCChangeRequestAlap::setCreateBOCChangeOrder()
     * @param \StructType\AuthenticationType $authentication
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     * @param \StructType\CreateBOCChangeType $createBOCChangeOrder
     */
    public function __construct(\StructType\AuthenticationType $authentication = null, \StructType\AlexBusinessFocusTypeAlap $focus = null, \StructType\CreateBOCChangeType $createBOCChangeOrder = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setFocus($focus)
            ->setCreateBOCChangeOrder($createBOCChangeOrder);
    }
    /**
     * Get authentication value
     * @return \StructType\AuthenticationType
     */
    public function getAuthentication()
    {
        return $this->authentication;
    }
    /**
     * Set authentication value
     * @param \StructType\AuthenticationType $authentication
     * @return \StructType\CreateBOCChangeRequestAlap
     */
    public function setAuthentication(\StructType\AuthenticationType $authentication = null)
    {
        $this->authentication = $authentication;
        return $this;
    }
    /**
     * Get focus value
     * @return \StructType\AlexBusinessFocusTypeAlap|null
     */
    public function getFocus()
    {
        return $this->focus;
    }
    /**
     * Set focus value
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     * @return \StructType\CreateBOCChangeRequestAlap
     */
    public function setFocus(\StructType\AlexBusinessFocusTypeAlap $focus = null)
    {
        $this->focus = $focus;
        return $this;
    }
    /**
     * Get createBOCChangeOrder value
     * @return \StructType\CreateBOCChangeType|null
     */
    public function getCreateBOCChangeOrder()
    {
        return $this->createBOCChangeOrder;
    }
    /**
     * Set createBOCChangeOrder value
     * @param \StructType\CreateBOCChangeType $createBOCChangeOrder
     * @return \StructType\CreateBOCChangeRequestAlap
     */
    public function setCreateBOCChangeOrder(\StructType\CreateBOCChangeType $createBOCChangeOrder = null)
    {
        $this->createBOCChangeOrder = $createBOCChangeOrder;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateBOCChangeRequestAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
