<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createSubscriptionRequestAlau StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-U request description for the method "createSubscription".
 * @subpackage Structs
 */
class CreateSubscriptionRequestAlau extends AbstractStructBase
{
    /**
     * The authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\AuthenticationType
     */
    public $authentication;
    /**
     * The subscription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\SubscriptionType
     */
    public $subscription;
    /**
     * The focus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\AlexBusinessFocusType
     */
    public $focus;
    /**
     * The reason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $reason;
    /**
     * Constructor method for createSubscriptionRequestAlau
     * @uses CreateSubscriptionRequestAlau::setAuthentication()
     * @uses CreateSubscriptionRequestAlau::setSubscription()
     * @uses CreateSubscriptionRequestAlau::setFocus()
     * @uses CreateSubscriptionRequestAlau::setReason()
     * @param \StructType\AuthenticationType $authentication
     * @param \StructType\SubscriptionType $subscription
     * @param \StructType\AlexBusinessFocusType $focus
     * @param string $reason
     */
    public function __construct(\StructType\AuthenticationType $authentication = null, \StructType\SubscriptionType $subscription = null, \StructType\AlexBusinessFocusType $focus = null, $reason = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setSubscription($subscription)
            ->setFocus($focus)
            ->setReason($reason);
    }
    /**
     * Get authentication value
     * @return \StructType\AuthenticationType
     */
    public function getAuthentication()
    {
        return $this->authentication;
    }
    /**
     * Set authentication value
     * @param \StructType\AuthenticationType $authentication
     * @return \StructType\CreateSubscriptionRequestAlau
     */
    public function setAuthentication(\StructType\AuthenticationType $authentication = null)
    {
        $this->authentication = $authentication;
        return $this;
    }
    /**
     * Get subscription value
     * @return \StructType\SubscriptionType
     */
    public function getSubscription()
    {
        return $this->subscription;
    }
    /**
     * Set subscription value
     * @param \StructType\SubscriptionType $subscription
     * @return \StructType\CreateSubscriptionRequestAlau
     */
    public function setSubscription(\StructType\SubscriptionType $subscription = null)
    {
        $this->subscription = $subscription;
        return $this;
    }
    /**
     * Get focus value
     * @return \StructType\AlexBusinessFocusType|null
     */
    public function getFocus()
    {
        return $this->focus;
    }
    /**
     * Set focus value
     * @param \StructType\AlexBusinessFocusType $focus
     * @return \StructType\CreateSubscriptionRequestAlau
     */
    public function setFocus(\StructType\AlexBusinessFocusType $focus = null)
    {
        $this->focus = $focus;
        return $this;
    }
    /**
     * Get reason value
     * @return string|null
     */
    public function getReason()
    {
        return $this->reason;
    }
    /**
     * Set reason value
     * @param string $reason
     * @return \StructType\CreateSubscriptionRequestAlau
     */
    public function setReason($reason = null)
    {
        // validation for constraint: string
        if (!is_null($reason) && !is_string($reason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reason, true), gettype($reason)), __LINE__);
        }
        $this->reason = $reason;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateSubscriptionRequestAlau
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
