<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerEndPointType StructType
 * @subpackage Structs
 */
class CustomerEndPointType extends SubscriptionEndPointType
{
    /**
     * The alapCustomerEndPointId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $alapCustomerEndPointId;
    /**
     * The firstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $firstName;
    /**
     * The lastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $lastName;
    /**
     * Constructor method for CustomerEndPointType
     * @uses CustomerEndPointType::setAlapCustomerEndPointId()
     * @uses CustomerEndPointType::setFirstName()
     * @uses CustomerEndPointType::setLastName()
     * @param string $alapCustomerEndPointId
     * @param string $firstName
     * @param string $lastName
     */
    public function __construct($alapCustomerEndPointId = null, $firstName = null, $lastName = null)
    {
        $this
            ->setAlapCustomerEndPointId($alapCustomerEndPointId)
            ->setFirstName($firstName)
            ->setLastName($lastName);
    }
    /**
     * Get alapCustomerEndPointId value
     * @return string|null
     */
    public function getAlapCustomerEndPointId()
    {
        return $this->alapCustomerEndPointId;
    }
    /**
     * Set alapCustomerEndPointId value
     * @param string $alapCustomerEndPointId
     * @return \StructType\CustomerEndPointType
     */
    public function setAlapCustomerEndPointId($alapCustomerEndPointId = null)
    {
        // validation for constraint: string
        if (!is_null($alapCustomerEndPointId) && !is_string($alapCustomerEndPointId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($alapCustomerEndPointId, true), gettype($alapCustomerEndPointId)), __LINE__);
        }
        $this->alapCustomerEndPointId = $alapCustomerEndPointId;
        return $this;
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \StructType\CustomerEndPointType
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get lastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param string $lastName
     * @return \StructType\CustomerEndPointType
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomerEndPointType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
