<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getAlapCustomerEndPointRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request description for the method "getAlapCustomerEndPoint".
 * @subpackage Structs
 */
class GetAlapCustomerEndPointRequest extends AbstractStructBase
{
    /**
     * The authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\AuthenticationType
     */
    public $authentication;
    /**
     * The customerEndPointSearchPattern
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\SubscriptionEndPointSearchPatternType
     */
    public $customerEndPointSearchPattern;
    /**
     * Constructor method for getAlapCustomerEndPointRequest
     * @uses GetAlapCustomerEndPointRequest::setAuthentication()
     * @uses GetAlapCustomerEndPointRequest::setCustomerEndPointSearchPattern()
     * @param \StructType\AuthenticationType $authentication
     * @param \StructType\SubscriptionEndPointSearchPatternType $customerEndPointSearchPattern
     */
    public function __construct(\StructType\AuthenticationType $authentication = null, \StructType\SubscriptionEndPointSearchPatternType $customerEndPointSearchPattern = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setCustomerEndPointSearchPattern($customerEndPointSearchPattern);
    }
    /**
     * Get authentication value
     * @return \StructType\AuthenticationType
     */
    public function getAuthentication()
    {
        return $this->authentication;
    }
    /**
     * Set authentication value
     * @param \StructType\AuthenticationType $authentication
     * @return \StructType\GetAlapCustomerEndPointRequest
     */
    public function setAuthentication(\StructType\AuthenticationType $authentication = null)
    {
        $this->authentication = $authentication;
        return $this;
    }
    /**
     * Get customerEndPointSearchPattern value
     * @return \StructType\SubscriptionEndPointSearchPatternType
     */
    public function getCustomerEndPointSearchPattern()
    {
        return $this->customerEndPointSearchPattern;
    }
    /**
     * Set customerEndPointSearchPattern value
     * @param \StructType\SubscriptionEndPointSearchPatternType $customerEndPointSearchPattern
     * @return \StructType\GetAlapCustomerEndPointRequest
     */
    public function setCustomerEndPointSearchPattern(\StructType\SubscriptionEndPointSearchPatternType $customerEndPointSearchPattern = null)
    {
        $this->customerEndPointSearchPattern = $customerEndPointSearchPattern;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAlapCustomerEndPointRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
