<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getAlapCustomerEndPointResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response description for the method "getAlapCustomerEndPoint".
 * @subpackage Structs
 */
class GetAlapCustomerEndPointResponse extends ResultType
{
    /**
     * The cep
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\CustomerEndPointType[]
     */
    public $cep;
    /**
     * Constructor method for getAlapCustomerEndPointResponse
     * @uses GetAlapCustomerEndPointResponse::setCep()
     * @param \StructType\CustomerEndPointType[] $cep
     */
    public function __construct(array $cep = array())
    {
        $this
            ->setCep($cep);
    }
    /**
     * Get cep value
     * @return \StructType\CustomerEndPointType[]|null
     */
    public function getCep()
    {
        return $this->cep;
    }
    /**
     * This method is responsible for validating the values passed to the setCep method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCep method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCepForArrayConstraintsFromSetCep(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getAlapCustomerEndPointResponseCepItem) {
            // validation for constraint: itemType
            if (!$getAlapCustomerEndPointResponseCepItem instanceof \StructType\CustomerEndPointType) {
                $invalidValues[] = is_object($getAlapCustomerEndPointResponseCepItem) ? get_class($getAlapCustomerEndPointResponseCepItem) : sprintf('%s(%s)', gettype($getAlapCustomerEndPointResponseCepItem), var_export($getAlapCustomerEndPointResponseCepItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The cep property can only contain items of type \StructType\CustomerEndPointType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set cep value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerEndPointType[] $cep
     * @return \StructType\GetAlapCustomerEndPointResponse
     */
    public function setCep(array $cep = array())
    {
        // validation for constraint: array
        if ('' !== ($cepArrayErrorMessage = self::validateCepForArrayConstraintsFromSetCep($cep))) {
            throw new \InvalidArgumentException($cepArrayErrorMessage, __LINE__);
        }
        $this->cep = $cep;
        return $this;
    }
    /**
     * Add item to cep value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerEndPointType $item
     * @return \StructType\GetAlapCustomerEndPointResponse
     */
    public function addToCep(\StructType\CustomerEndPointType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerEndPointType) {
            throw new \InvalidArgumentException(sprintf('The cep property can only contain items of type \StructType\CustomerEndPointType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->cep[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAlapCustomerEndPointResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
