<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getAvailableServicesResponseAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P response description for the method "getAvailableServices".
 * @subpackage Structs
 */
class GetAvailableServicesResponseAlap extends ResultType
{
    /**
     * The service
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\ServiceReturnType[]
     */
    public $service;
    /**
     * Constructor method for getAvailableServicesResponseAlap
     * @uses GetAvailableServicesResponseAlap::setService()
     * @param \StructType\ServiceReturnType[] $service
     */
    public function __construct(array $service = array())
    {
        $this
            ->setService($service);
    }
    /**
     * Get service value
     * @return \StructType\ServiceReturnType[]|null
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * This method is responsible for validating the values passed to the setService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceForArrayConstraintsFromSetService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getAvailableServicesResponseAlapServiceItem) {
            // validation for constraint: itemType
            if (!$getAvailableServicesResponseAlapServiceItem instanceof \StructType\ServiceReturnType) {
                $invalidValues[] = is_object($getAvailableServicesResponseAlapServiceItem) ? get_class($getAvailableServicesResponseAlapServiceItem) : sprintf('%s(%s)', gettype($getAvailableServicesResponseAlapServiceItem), var_export($getAvailableServicesResponseAlapServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The service property can only contain items of type \StructType\ServiceReturnType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set service value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceReturnType[] $service
     * @return \StructType\GetAvailableServicesResponseAlap
     */
    public function setService(array $service = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceArrayErrorMessage = self::validateServiceForArrayConstraintsFromSetService($service))) {
            throw new \InvalidArgumentException($serviceArrayErrorMessage, __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Add item to service value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceReturnType $item
     * @return \StructType\GetAvailableServicesResponseAlap
     */
    public function addToService(\StructType\ServiceReturnType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceReturnType) {
            throw new \InvalidArgumentException(sprintf('The service property can only contain items of type \StructType\ServiceReturnType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->service[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAvailableServicesResponseAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
