<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getBOCChangeInformationResponseAlau StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-U response description for the method "getBOCChangeInformation".
 * @subpackage Structs
 */
class GetBOCChangeInformationResponseAlau extends ResultType
{
    /**
     * The bocChangeOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\BOCChangeOrderType[]
     */
    public $bocChangeOrder;
    /**
     * Constructor method for getBOCChangeInformationResponseAlau
     * @uses GetBOCChangeInformationResponseAlau::setBocChangeOrder()
     * @param \StructType\BOCChangeOrderType[] $bocChangeOrder
     */
    public function __construct(array $bocChangeOrder = array())
    {
        $this
            ->setBocChangeOrder($bocChangeOrder);
    }
    /**
     * Get bocChangeOrder value
     * @return \StructType\BOCChangeOrderType[]|null
     */
    public function getBocChangeOrder()
    {
        return $this->bocChangeOrder;
    }
    /**
     * This method is responsible for validating the values passed to the setBocChangeOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBocChangeOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBocChangeOrderForArrayConstraintsFromSetBocChangeOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getBOCChangeInformationResponseAlauBocChangeOrderItem) {
            // validation for constraint: itemType
            if (!$getBOCChangeInformationResponseAlauBocChangeOrderItem instanceof \StructType\BOCChangeOrderType) {
                $invalidValues[] = is_object($getBOCChangeInformationResponseAlauBocChangeOrderItem) ? get_class($getBOCChangeInformationResponseAlauBocChangeOrderItem) : sprintf('%s(%s)', gettype($getBOCChangeInformationResponseAlauBocChangeOrderItem), var_export($getBOCChangeInformationResponseAlauBocChangeOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bocChangeOrder property can only contain items of type \StructType\BOCChangeOrderType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bocChangeOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\BOCChangeOrderType[] $bocChangeOrder
     * @return \StructType\GetBOCChangeInformationResponseAlau
     */
    public function setBocChangeOrder(array $bocChangeOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($bocChangeOrderArrayErrorMessage = self::validateBocChangeOrderForArrayConstraintsFromSetBocChangeOrder($bocChangeOrder))) {
            throw new \InvalidArgumentException($bocChangeOrderArrayErrorMessage, __LINE__);
        }
        $this->bocChangeOrder = $bocChangeOrder;
        return $this;
    }
    /**
     * Add item to bocChangeOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\BOCChangeOrderType $item
     * @return \StructType\GetBOCChangeInformationResponseAlau
     */
    public function addToBocChangeOrder(\StructType\BOCChangeOrderType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BOCChangeOrderType) {
            throw new \InvalidArgumentException(sprintf('The bocChangeOrder property can only contain items of type \StructType\BOCChangeOrderType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bocChangeOrder[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBOCChangeInformationResponseAlau
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
