<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getSubscriptionEndPointInformationResponseAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P response description for the method "getSubscriptionEndPointInformation".
 * @subpackage Structs
 */
class GetSubscriptionEndPointInformationResponseAlap extends ResultBasicType
{
    /**
     * The alap
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\SepResultType[]
     */
    public $alap;
    /**
     * Constructor method for getSubscriptionEndPointInformationResponseAlap
     * @uses GetSubscriptionEndPointInformationResponseAlap::setAlap()
     * @param \StructType\SepResultType[] $alap
     */
    public function __construct(array $alap = array())
    {
        $this
            ->setAlap($alap);
    }
    /**
     * Get alap value
     * @return \StructType\SepResultType[]|null
     */
    public function getAlap()
    {
        return $this->alap;
    }
    /**
     * This method is responsible for validating the values passed to the setAlap method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlap method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlapForArrayConstraintsFromSetAlap(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getSubscriptionEndPointInformationResponseAlapAlapItem) {
            // validation for constraint: itemType
            if (!$getSubscriptionEndPointInformationResponseAlapAlapItem instanceof \StructType\SepResultType) {
                $invalidValues[] = is_object($getSubscriptionEndPointInformationResponseAlapAlapItem) ? get_class($getSubscriptionEndPointInformationResponseAlapAlapItem) : sprintf('%s(%s)', gettype($getSubscriptionEndPointInformationResponseAlapAlapItem), var_export($getSubscriptionEndPointInformationResponseAlapAlapItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The alap property can only contain items of type \StructType\SepResultType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set alap value
     * @throws \InvalidArgumentException
     * @param \StructType\SepResultType[] $alap
     * @return \StructType\GetSubscriptionEndPointInformationResponseAlap
     */
    public function setAlap(array $alap = array())
    {
        // validation for constraint: array
        if ('' !== ($alapArrayErrorMessage = self::validateAlapForArrayConstraintsFromSetAlap($alap))) {
            throw new \InvalidArgumentException($alapArrayErrorMessage, __LINE__);
        }
        $this->alap = $alap;
        return $this;
    }
    /**
     * Add item to alap value
     * @throws \InvalidArgumentException
     * @param \StructType\SepResultType $item
     * @return \StructType\GetSubscriptionEndPointInformationResponseAlap
     */
    public function addToAlap(\StructType\SepResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SepResultType) {
            throw new \InvalidArgumentException(sprintf('The alap property can only contain items of type \StructType\SepResultType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->alap[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSubscriptionEndPointInformationResponseAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
