<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getTicketResponseAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P response description for the method "getTicket".
 * @subpackage Structs
 */
class GetTicketResponseAlap extends ResultType
{
    /**
     * The ticket
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\TicketType[]
     */
    public $ticket;
    /**
     * Constructor method for getTicketResponseAlap
     * @uses GetTicketResponseAlap::setTicket()
     * @param \StructType\TicketType[] $ticket
     */
    public function __construct(array $ticket = array())
    {
        $this
            ->setTicket($ticket);
    }
    /**
     * Get ticket value
     * @return \StructType\TicketType[]|null
     */
    public function getTicket()
    {
        return $this->ticket;
    }
    /**
     * This method is responsible for validating the values passed to the setTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTicketForArrayConstraintsFromSetTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getTicketResponseAlapTicketItem) {
            // validation for constraint: itemType
            if (!$getTicketResponseAlapTicketItem instanceof \StructType\TicketType) {
                $invalidValues[] = is_object($getTicketResponseAlapTicketItem) ? get_class($getTicketResponseAlapTicketItem) : sprintf('%s(%s)', gettype($getTicketResponseAlapTicketItem), var_export($getTicketResponseAlapTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ticket property can only contain items of type \StructType\TicketType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ticket value
     * @throws \InvalidArgumentException
     * @param \StructType\TicketType[] $ticket
     * @return \StructType\GetTicketResponseAlap
     */
    public function setTicket(array $ticket = array())
    {
        // validation for constraint: array
        if ('' !== ($ticketArrayErrorMessage = self::validateTicketForArrayConstraintsFromSetTicket($ticket))) {
            throw new \InvalidArgumentException($ticketArrayErrorMessage, __LINE__);
        }
        $this->ticket = $ticket;
        return $this;
    }
    /**
     * Add item to ticket value
     * @throws \InvalidArgumentException
     * @param \StructType\TicketType $item
     * @return \StructType\GetTicketResponseAlap
     */
    public function addToTicket(\StructType\TicketType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TicketType) {
            throw new \InvalidArgumentException(sprintf('The ticket property can only contain items of type \StructType\TicketType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ticket[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTicketResponseAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
