<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for L1BreakoutType StructType
 * @subpackage Structs
 */
class L1BreakoutType extends AbstractStructBase
{
    /**
     * The breakoutCable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $breakoutCable;
    /**
     * The breakoutFiber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $breakoutFiber;
    /**
     * Constructor method for L1BreakoutType
     * @uses L1BreakoutType::setBreakoutCable()
     * @uses L1BreakoutType::setBreakoutFiber()
     * @param string $breakoutCable
     * @param string $breakoutFiber
     */
    public function __construct($breakoutCable = null, $breakoutFiber = null)
    {
        $this
            ->setBreakoutCable($breakoutCable)
            ->setBreakoutFiber($breakoutFiber);
    }
    /**
     * Get breakoutCable value
     * @return string|null
     */
    public function getBreakoutCable()
    {
        return $this->breakoutCable;
    }
    /**
     * Set breakoutCable value
     * @param string $breakoutCable
     * @return \StructType\L1BreakoutType
     */
    public function setBreakoutCable($breakoutCable = null)
    {
        // validation for constraint: string
        if (!is_null($breakoutCable) && !is_string($breakoutCable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($breakoutCable, true), gettype($breakoutCable)), __LINE__);
        }
        $this->breakoutCable = $breakoutCable;
        return $this;
    }
    /**
     * Get breakoutFiber value
     * @return string|null
     */
    public function getBreakoutFiber()
    {
        return $this->breakoutFiber;
    }
    /**
     * Set breakoutFiber value
     * @param string $breakoutFiber
     * @return \StructType\L1BreakoutType
     */
    public function setBreakoutFiber($breakoutFiber = null)
    {
        // validation for constraint: string
        if (!is_null($breakoutFiber) && !is_string($breakoutFiber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($breakoutFiber, true), gettype($breakoutFiber)), __LINE__);
        }
        $this->breakoutFiber = $breakoutFiber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\L1BreakoutType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
