<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for L1HandoverEquipmentType StructType
 * @subpackage Structs
 */
class L1HandoverEquipmentType extends AbstractStructBase
{
    /**
     * The l1HandoverEquipmentName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $l1HandoverEquipmentName;
    /**
     * The l1HandoverEquipmentRack
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $l1HandoverEquipmentRack;
    /**
     * The l1HandoverEquipmentSlot
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $l1HandoverEquipmentSlot;
    /**
     * The l1HandoverEquipmentPort
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $l1HandoverEquipmentPort;
    /**
     * Constructor method for L1HandoverEquipmentType
     * @uses L1HandoverEquipmentType::setL1HandoverEquipmentName()
     * @uses L1HandoverEquipmentType::setL1HandoverEquipmentRack()
     * @uses L1HandoverEquipmentType::setL1HandoverEquipmentSlot()
     * @uses L1HandoverEquipmentType::setL1HandoverEquipmentPort()
     * @param string $l1HandoverEquipmentName
     * @param string $l1HandoverEquipmentRack
     * @param string $l1HandoverEquipmentSlot
     * @param string $l1HandoverEquipmentPort
     */
    public function __construct($l1HandoverEquipmentName = null, $l1HandoverEquipmentRack = null, $l1HandoverEquipmentSlot = null, $l1HandoverEquipmentPort = null)
    {
        $this
            ->setL1HandoverEquipmentName($l1HandoverEquipmentName)
            ->setL1HandoverEquipmentRack($l1HandoverEquipmentRack)
            ->setL1HandoverEquipmentSlot($l1HandoverEquipmentSlot)
            ->setL1HandoverEquipmentPort($l1HandoverEquipmentPort);
    }
    /**
     * Get l1HandoverEquipmentName value
     * @return string
     */
    public function getL1HandoverEquipmentName()
    {
        return $this->l1HandoverEquipmentName;
    }
    /**
     * Set l1HandoverEquipmentName value
     * @param string $l1HandoverEquipmentName
     * @return \StructType\L1HandoverEquipmentType
     */
    public function setL1HandoverEquipmentName($l1HandoverEquipmentName = null)
    {
        // validation for constraint: string
        if (!is_null($l1HandoverEquipmentName) && !is_string($l1HandoverEquipmentName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($l1HandoverEquipmentName, true), gettype($l1HandoverEquipmentName)), __LINE__);
        }
        $this->l1HandoverEquipmentName = $l1HandoverEquipmentName;
        return $this;
    }
    /**
     * Get l1HandoverEquipmentRack value
     * @return string|null
     */
    public function getL1HandoverEquipmentRack()
    {
        return $this->l1HandoverEquipmentRack;
    }
    /**
     * Set l1HandoverEquipmentRack value
     * @param string $l1HandoverEquipmentRack
     * @return \StructType\L1HandoverEquipmentType
     */
    public function setL1HandoverEquipmentRack($l1HandoverEquipmentRack = null)
    {
        // validation for constraint: string
        if (!is_null($l1HandoverEquipmentRack) && !is_string($l1HandoverEquipmentRack)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($l1HandoverEquipmentRack, true), gettype($l1HandoverEquipmentRack)), __LINE__);
        }
        $this->l1HandoverEquipmentRack = $l1HandoverEquipmentRack;
        return $this;
    }
    /**
     * Get l1HandoverEquipmentSlot value
     * @return string|null
     */
    public function getL1HandoverEquipmentSlot()
    {
        return $this->l1HandoverEquipmentSlot;
    }
    /**
     * Set l1HandoverEquipmentSlot value
     * @param string $l1HandoverEquipmentSlot
     * @return \StructType\L1HandoverEquipmentType
     */
    public function setL1HandoverEquipmentSlot($l1HandoverEquipmentSlot = null)
    {
        // validation for constraint: string
        if (!is_null($l1HandoverEquipmentSlot) && !is_string($l1HandoverEquipmentSlot)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($l1HandoverEquipmentSlot, true), gettype($l1HandoverEquipmentSlot)), __LINE__);
        }
        $this->l1HandoverEquipmentSlot = $l1HandoverEquipmentSlot;
        return $this;
    }
    /**
     * Get l1HandoverEquipmentPort value
     * @return string|null
     */
    public function getL1HandoverEquipmentPort()
    {
        return $this->l1HandoverEquipmentPort;
    }
    /**
     * Set l1HandoverEquipmentPort value
     * @param string $l1HandoverEquipmentPort
     * @return \StructType\L1HandoverEquipmentType
     */
    public function setL1HandoverEquipmentPort($l1HandoverEquipmentPort = null)
    {
        // validation for constraint: string
        if (!is_null($l1HandoverEquipmentPort) && !is_string($l1HandoverEquipmentPort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($l1HandoverEquipmentPort, true), gettype($l1HandoverEquipmentPort)), __LINE__);
        }
        $this->l1HandoverEquipmentPort = $l1HandoverEquipmentPort;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\L1HandoverEquipmentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
