<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceReturnType StructType
 * @subpackage Structs
 */
class ServiceReturnType extends AbstractStructBase
{
    /**
     * The serviceType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\ServiceType
     */
    public $serviceType;
    /**
     * The serviceConditions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\ServiceConditionsType
     */
    public $serviceConditions;
    /**
     * Constructor method for ServiceReturnType
     * @uses ServiceReturnType::setServiceType()
     * @uses ServiceReturnType::setServiceConditions()
     * @param \StructType\ServiceType $serviceType
     * @param \StructType\ServiceConditionsType $serviceConditions
     */
    public function __construct(\StructType\ServiceType $serviceType = null, \StructType\ServiceConditionsType $serviceConditions = null)
    {
        $this
            ->setServiceType($serviceType)
            ->setServiceConditions($serviceConditions);
    }
    /**
     * Get serviceType value
     * @return \StructType\ServiceType|null
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }
    /**
     * Set serviceType value
     * @param \StructType\ServiceType $serviceType
     * @return \StructType\ServiceReturnType
     */
    public function setServiceType(\StructType\ServiceType $serviceType = null)
    {
        $this->serviceType = $serviceType;
        return $this;
    }
    /**
     * Get serviceConditions value
     * @return \StructType\ServiceConditionsType|null
     */
    public function getServiceConditions()
    {
        return $this->serviceConditions;
    }
    /**
     * Set serviceConditions value
     * @param \StructType\ServiceConditionsType $serviceConditions
     * @return \StructType\ServiceReturnType
     */
    public function setServiceConditions(\StructType\ServiceConditionsType $serviceConditions = null)
    {
        $this->serviceConditions = $serviceConditions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServiceReturnType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
