<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubscriptionSearchPatternType StructType
 * @subpackage Structs
 */
class SubscriptionSearchPatternType extends SubscriptionType
{
    /**
     * The fiberConnection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\FiberConnectionType
     */
    public $fiberConnection;
    /**
     * The modificationDateTimeTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $modificationDateTimeTo;
    /**
     * Constructor method for SubscriptionSearchPatternType
     * @uses SubscriptionSearchPatternType::setFiberConnection()
     * @uses SubscriptionSearchPatternType::setModificationDateTimeTo()
     * @param \StructType\FiberConnectionType $fiberConnection
     * @param string $modificationDateTimeTo
     */
    public function __construct(\StructType\FiberConnectionType $fiberConnection = null, $modificationDateTimeTo = null)
    {
        $this
            ->setFiberConnection($fiberConnection)
            ->setModificationDateTimeTo($modificationDateTimeTo);
    }
    /**
     * Get fiberConnection value
     * @return \StructType\FiberConnectionType|null
     */
    public function getFiberConnection()
    {
        return $this->fiberConnection;
    }
    /**
     * Set fiberConnection value
     * @param \StructType\FiberConnectionType $fiberConnection
     * @return \StructType\SubscriptionSearchPatternType
     */
    public function setFiberConnection(\StructType\FiberConnectionType $fiberConnection = null)
    {
        $this->fiberConnection = $fiberConnection;
        return $this;
    }
    /**
     * Get modificationDateTimeTo value
     * @return string|null
     */
    public function getModificationDateTimeTo()
    {
        return $this->modificationDateTimeTo;
    }
    /**
     * Set modificationDateTimeTo value
     * @param string $modificationDateTimeTo
     * @return \StructType\SubscriptionSearchPatternType
     */
    public function setModificationDateTimeTo($modificationDateTimeTo = null)
    {
        // validation for constraint: string
        if (!is_null($modificationDateTimeTo) && !is_string($modificationDateTimeTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modificationDateTimeTo, true), gettype($modificationDateTimeTo)), __LINE__);
        }
        $this->modificationDateTimeTo = $modificationDateTimeTo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscriptionSearchPatternType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
