<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TicketSearchPatternType StructType
 * @subpackage Structs
 */
class TicketSearchPatternType extends TicketType
{
    /**
     * The tIdTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var int
     */
    public $tIdTo;
    /**
     * The tCreationTimestampTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $tCreationTimestampTo;
    /**
     * The lastModifiedTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $lastModifiedTo;
    /**
     * Constructor method for TicketSearchPatternType
     * @uses TicketSearchPatternType::setTIdTo()
     * @uses TicketSearchPatternType::setTCreationTimestampTo()
     * @uses TicketSearchPatternType::setLastModifiedTo()
     * @param int $tIdTo
     * @param string $tCreationTimestampTo
     * @param string $lastModifiedTo
     */
    public function __construct($tIdTo = null, $tCreationTimestampTo = null, $lastModifiedTo = null)
    {
        $this
            ->setTIdTo($tIdTo)
            ->setTCreationTimestampTo($tCreationTimestampTo)
            ->setLastModifiedTo($lastModifiedTo);
    }
    /**
     * Get tIdTo value
     * @return int|null
     */
    public function getTIdTo()
    {
        return $this->tIdTo;
    }
    /**
     * Set tIdTo value
     * @param int $tIdTo
     * @return \StructType\TicketSearchPatternType
     */
    public function setTIdTo($tIdTo = null)
    {
        // validation for constraint: int
        if (!is_null($tIdTo) && !(is_int($tIdTo) || ctype_digit($tIdTo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tIdTo, true), gettype($tIdTo)), __LINE__);
        }
        $this->tIdTo = $tIdTo;
        return $this;
    }
    /**
     * Get tCreationTimestampTo value
     * @return string|null
     */
    public function getTCreationTimestampTo()
    {
        return $this->tCreationTimestampTo;
    }
    /**
     * Set tCreationTimestampTo value
     * @param string $tCreationTimestampTo
     * @return \StructType\TicketSearchPatternType
     */
    public function setTCreationTimestampTo($tCreationTimestampTo = null)
    {
        // validation for constraint: string
        if (!is_null($tCreationTimestampTo) && !is_string($tCreationTimestampTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tCreationTimestampTo, true), gettype($tCreationTimestampTo)), __LINE__);
        }
        $this->tCreationTimestampTo = $tCreationTimestampTo;
        return $this;
    }
    /**
     * Get lastModifiedTo value
     * @return string|null
     */
    public function getLastModifiedTo()
    {
        return $this->lastModifiedTo;
    }
    /**
     * Set lastModifiedTo value
     * @param string $lastModifiedTo
     * @return \StructType\TicketSearchPatternType
     */
    public function setLastModifiedTo($lastModifiedTo = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedTo) && !is_string($lastModifiedTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModifiedTo, true), gettype($lastModifiedTo)), __LINE__);
        }
        $this->lastModifiedTo = $lastModifiedTo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TicketSearchPatternType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
