<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateTicketRequestAlap StructType
 * Meta information extracted from the WSDL
 * - documentation: ALA-P request description for the method "updateTicket".
 * @subpackage Structs
 */
class UpdateTicketRequestAlap extends AbstractStructBase
{
    /**
     * The authentication
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\AuthenticationType
     */
    public $authentication;
    /**
     * The updateTicket
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\UpdateTicketType
     */
    public $updateTicket;
    /**
     * The focus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\AlexBusinessFocusTypeAlap
     */
    public $focus;
    /**
     * Constructor method for updateTicketRequestAlap
     * @uses UpdateTicketRequestAlap::setAuthentication()
     * @uses UpdateTicketRequestAlap::setUpdateTicket()
     * @uses UpdateTicketRequestAlap::setFocus()
     * @param \StructType\AuthenticationType $authentication
     * @param \StructType\UpdateTicketType $updateTicket
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     */
    public function __construct(\StructType\AuthenticationType $authentication = null, \StructType\UpdateTicketType $updateTicket = null, \StructType\AlexBusinessFocusTypeAlap $focus = null)
    {
        $this
            ->setAuthentication($authentication)
            ->setUpdateTicket($updateTicket)
            ->setFocus($focus);
    }
    /**
     * Get authentication value
     * @return \StructType\AuthenticationType
     */
    public function getAuthentication()
    {
        return $this->authentication;
    }
    /**
     * Set authentication value
     * @param \StructType\AuthenticationType $authentication
     * @return \StructType\UpdateTicketRequestAlap
     */
    public function setAuthentication(\StructType\AuthenticationType $authentication = null)
    {
        $this->authentication = $authentication;
        return $this;
    }
    /**
     * Get updateTicket value
     * @return \StructType\UpdateTicketType
     */
    public function getUpdateTicket()
    {
        return $this->updateTicket;
    }
    /**
     * Set updateTicket value
     * @param \StructType\UpdateTicketType $updateTicket
     * @return \StructType\UpdateTicketRequestAlap
     */
    public function setUpdateTicket(\StructType\UpdateTicketType $updateTicket = null)
    {
        $this->updateTicket = $updateTicket;
        return $this;
    }
    /**
     * Get focus value
     * @return \StructType\AlexBusinessFocusTypeAlap|null
     */
    public function getFocus()
    {
        return $this->focus;
    }
    /**
     * Set focus value
     * @param \StructType\AlexBusinessFocusTypeAlap $focus
     * @return \StructType\UpdateTicketRequestAlap
     */
    public function setFocus(\StructType\AlexBusinessFocusTypeAlap $focus = null)
    {
        $this->focus = $focus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateTicketRequestAlap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
